;/******************************************************************************/
;/* startup_sh30f9820_gcc.S: Startup file for Sinowealth SH30F9820 device series */
;/******************************************************************************/
;/* This file is generated for gcc compiler                                    */
;/******************************************************************************/
;/*
;/* SINOWEALTH IS SUPPLYING THIS SOFTWARE FOR USE EXCLUSIVELY ON SINOWEALTH
;/* MICROCONTROLLER PRODUCTS. IT IS PROTECTED UNDER APPLICABLE COPYRIGHT LAWS. 
;/* THIS SOFTWARE IS FOR GUIDANCE IN ORDER TO SAVE TIME. AS A RESULT, SINOWEALTH 
;/* SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES 
;/* WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT OF SUCH FIRMWARE AND/OR
;/* THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN 
;/* CONNECTION WITH THEIR PRODUCTS.
;/*
;/* <h2><center>&copy; COPYRIGHT 2017 Sinowealth</center></h2>
;/*
;/******************************************************************************
;/*/

    .syntax unified
    .cpu cortex-m0plus
    .thumb
    
    .global    Reset_Handler

    .section  .data.stack,"w"
    .skip  0x200   /*stack size*/
    _estack:

   
    .section  .isr_vector ,"a",%progbits
     .long    _estack              ;/* -16 (000H) Top of Stack                                  */
     .long    Reset_Handler        ;/* -15 (004H) Reset Handler                                 */
     .long    NMI_Handler          ;/* -14 (008H) Non Maskable Interrupt                        */
     .long    HardFault_Handler    ;/* -13 (00CH) Hard Fault Interrupt                          */
     .long    Default_Handler      ;/* -12 (010H) Reserved                                      */
     .long    Default_Handler      ;/* -11 (014H) Reserved                                      */
     .long    Default_Handler      ;/* -10 (018H) Reserved                                      */
     .long    Default_Handler      ;/*  -9 (01CH) Reserved                                      */
     .long    Default_Handler      ;/*  -8 (020H) Reserved                                      */
     .long    Default_Handler      ;/*  -7 (024H) Reserved                                      */
     .long    Default_Handler      ;/*  -6 (028H) Reserved                                      */
     .long    SVC_Handler          ;/*  -5 (02CH) Cortex-M0+ SV Call Interrupt                  */
     .long    Default_Handler      ;/*  -4 (030H) Reserved                                      */
     .long    Default_Handler      ;/*  -3 (034H) Reserved                                      */
     .long    PendSV_Handler       ;/*  -2 (038H) Cortex-M0+ Pend SV Interrupt                  */
     .long    SysTick_Handler      ;/*  -1 (03CH) Cortex-M0+ System Tick Interrupt              */
     .long    WWDT_Handler         ;/*   0 (040H) Window WatchDog Interrupt                     */
     .long    BOD_Handler          ;/*   1 (044H) PVD through EXTI Line detection Interrupt     */
     .long    RCC_Handler          ;/*   2 (048H) RCC global Interrupt                          */
     .long    EXTI0_Handler        ;/*   3 (04CH) EXTI Line0 Interrupt                          */
     .long    EXTI1_Handler        ;/*   4 (050H) EXTI Line1 Interrupt                          */
     .long    EXTI2_Handler        ;/*   5 (054H) EXTI Line2 Interrupt                          */
     .long    EXTI3_Handler        ;/*   6 (058H) EXTI Line3 Interrupt                          */
     .long    DMA_CH0_1_Handler    ;/*   7 (05CH) DMA Channel0 ~ Channel1 Interrupt             */
     .long    DMA_CH2_3_Handler    ;/*   8 (060H) DMA Channel2 ~ Channel3 Interrupt             */
     .long    ADC_Handler          ;/*   9 (064H) ADC Interrupt                                 */
     .long    PWM0_Handler         ;/*  10 (068H) PWM0 Interrupt                                */
     .long    PWM1_Handler         ;/*  11 (06CH) PWM1 Interrupt                                */
     .long    PWM2_Handler         ;/*  12 (070H) PWM2 Interrupt                                */
     .long    PWM3_Handler         ;/*  13 (074H) PWM3 Interrupt                                */
     .long    PCA0_Handler         ;/*  14 (078H) PCA0 Interrupt                                */
     .long    PCA1_Handler         ;/*  15 (07CH) PCA1 Interrupt                                */
     .long    PCA2_Handler         ;/*  16 (080H) PCA2 Interrupt                                */
     .long    PCA3_Handler         ;/*  17 (084H) PCA3 Interrupt                                */
     .long    EXTI9_4_Handler      ;/*  18 (088H) EXTI Line4 ~ Line9 global Interrupt           */
     .long    UART0_Handler        ;/*  19 (08CH) UART0 Interrupt                               */
     .long    TWI0_Handler         ;/*  20 (090H) TWI0 Interrupt                                */
     .long    SPI0_Handler         ;/*  21 (094H) SPI0 Interrupt                                */
     .long    SPI1_LED_Handler     ;/*  22 (098H) SPI1&LED Interrupt                            */
     .long    UART1_Handler        ;/*  23 (09CH) UART1 Interrupt                               */
     .long    UART2_Handler        ;/*  24 (0A0H) UART2 Interrupt                               */
     .long    UART3_Handler        ;/*  25 (0A4H) UART3 Interrupt                               */
     .long    EXTI15_10_Handler    ;/*  26 (0A8H) EXTI Line10 ~ Line15 Interrupt                */
     .long    TIM0_Handler         ;/*  27 (0ACH) TIM0 Interrupt                                */
     .long    TIM1_Handler         ;/*  28 (0B0H) TIM1 Interrupt                                */
     .long    TIM2_Handler         ;/*  29 (0B4H) TIM2 Interrupt                                */
     .long    TIM3_Handler         ;/*  30 (0B8H) TIM3 Interrupt                                */
     .long    TouchKey_Handler     ;/*  31 (0BCH) TouchKey Interrupt                            */
    
      .section  .text.Reset_Handler,"ax",%progbits
      .type Reset_Handler, %function
Reset_Handler:

    /* Call the low level init function.*/
    bl  SystemInit   
    
    movs r1, #0
    b    LoopCopyDataInit

CopyDataInit:
    ldr  r3, =_sidata
    ldr  r3, [r3, r1]
    str  r3, [r0, r1]
    adds r1, r1, #4
    
LoopCopyDataInit:
    ldr  r0, =_sdata
    ldr  r3, =_edata
    adds r2, r0, r1
    cmp  r2, r3
    bcc  CopyDataInit
    ldr  r2, =_sbss
    b    LoopFillZerobss
  
    ;/* Zero fill the bss segment. */  

FillZerobss:
    movs r3, #0
    str r3,[r2]
    adds r2,r2,#4
    
LoopFillZerobss:
    ldr r3, =_ebss
    cmp r2, r3
    bcc FillZerobss
  
   /* Call static constructors */
   /* bl  __libc_init_array*/
	
  /* Call the application's entry point.*/
    bl  main
    bx  lr    
    b  .  
    
    .size  Reset_Handler, .-Reset_Handler
    
    .weak      NMI_Handler
    .thumb_set NMI_Handler,          System_Handler
  
    .weak      HardFault_Handler
    .thumb_set HardFault_Handler,    System_Handler
  
    .weak      MemManage_Handler
    .thumb_set MemManage_Handler,    System_Handler
  
    .weak      BusFault_Handler
    .thumb_set BusFault_Handler,     System_Handler

    .weak      UsageFault_Handler
    .thumb_set UsageFault_Handler,   System_Handler

    .weak      SVC_Handler
    .thumb_set SVC_Handler,          System_Handler

    .weak      DebugMon_Handler
    .thumb_set DebugMon_Handler,     System_Handler

    .weak      PendSV_Handler
    .thumb_set PendSV_Handler,       System_Handler

    .weak      SysTick_Handler
    .thumb_set SysTick_Handler,      System_Handler    

    .weak      WWDT_Handler        
    .thumb_set WWDT_Handler,        User_Handler
    .weak      BOD_Handler         
    .thumb_set BOD_Handler,         User_Handler
    .weak      RCC_Handler         
    .thumb_set RCC_Handler,         User_Handler
    .weak      EXTI0_Handler       
    .thumb_set EXTI0_Handler,       User_Handler
    .weak      EXTI1_Handler       
    .thumb_set EXTI1_Handler,       User_Handler
    .weak      EXTI2_Handler       
    .thumb_set EXTI2_Handler,       User_Handler
    .weak      EXTI3_Handler       
    .thumb_set EXTI3_Handler,       User_Handler
    .weak      DMA_CH0_1_Handler   
    .thumb_set DMA_CH0_1_Handler,   User_Handler
    .weak      DMA_CH2_3_Handler   
    .thumb_set DMA_CH2_3_Handler,   User_Handler
    .weak      ADC_Handler         
    .thumb_set ADC_Handler,         User_Handler
    .weak      PWM0_Handler        
    .thumb_set PWM0_Handler,        User_Handler
    .weak      PWM1_Handler        
    .thumb_set PWM1_Handler,        User_Handler
    .weak      PWM2_Handler        
    .thumb_set PWM2_Handler,        User_Handler
    .weak      PWM3_Handler        
    .thumb_set PWM3_Handler,        User_Handler
    .weak      PCA0_Handler        
    .thumb_set PCA0_Handler,        User_Handler
    .weak      PCA1_Handler        
    .thumb_set PCA1_Handler,        User_Handler
    .weak      PCA2_Handler        
    .thumb_set PCA2_Handler,        User_Handler
    .weak      PCA3_Handler        
    .thumb_set PCA3_Handler,        User_Handler
    .weak      EXTI9_4_Handler     
    .thumb_set EXTI9_4_Handler,     User_Handler
    .weak      UART0_Handler       
    .thumb_set UART0_Handler,       User_Handler
    .weak      TWI0_Handler        
    .thumb_set TWI0_Handler,        User_Handler
    .weak      SPI0_Handler        
    .thumb_set SPI0_Handler,        User_Handler
    .weak      SPI1_LED_Handler    
    .thumb_set SPI1_LED_Handler,    User_Handler
    .weak      UART1_Handler       
    .thumb_set UART1_Handler,       User_Handler
    .weak      UART2_Handler       
    .thumb_set UART2_Handler,       User_Handler
    .weak      UART3_Handler       
    .thumb_set UART3_Handler,       User_Handler
    .weak      EXTI15_10_Handler   
    .thumb_set EXTI15_10_Handler,   User_Handler
    .weak      TIM0_Handler        
    .thumb_set TIM0_Handler,        User_Handler
    .weak      TIM1_Handler        
    .thumb_set TIM1_Handler,        User_Handler
    .weak      TIM2_Handler        
    .thumb_set TIM2_Handler,        User_Handler
    .weak      TIM3_Handler        
    .thumb_set TIM3_Handler,        User_Handler
    .weak      TouchKey_Handler    
    .thumb_set TouchKey_Handler,    User_Handler
   
    .section  .text.System_Handler,"ax",%progbits
    .type System_Handler, %function
System_Handler:
   b  .
   .size  System_Handler, .-System_Handler
   
    .section  .text.Default_Handler,"ax",%progbits
    .type Default_Handler, %function
Default_Handler:
   b  .   
   .size  Default_Handler, .-Default_Handler

 
    .section  .text.User_Handler,"ax",%progbits
    .type User_Handler, %function
User_Handler:
   b  .
   .size  User_Handler, .-User_Handler
               
   .weak SystemInit
   .thumb_set SystemInit, SystemInit_Default
   .section  .text.SystemInit,"ax",%progbits   
   .type SystemInit_Default, %function
SystemInit_Default:
   bx lr
   .size SystemInit_Default, .-SystemInit_Default
   
   
