/**
  ******************************************************************************
  * @file    sh30f9xx_sa0_retarget.h
  * @author  sinowealth
  * @version V1.1.0
  * @date    16-June-2021
  * @brief   This file contains all the functions prototypes for the retarget firmware
  *          library.
  ******************************************************************************
  * @attention
  *
  * SINOWEALTH IS SUPPLYING THIS SOFTWARE FOR USE EXCLUSIVELY ON SINOWEALTH'S
  * MICROCONTROLLER PRODUCTS. IT IS PROTECTED UNDER APPLICABLE COPYRIGHT LAWS.
  * THIS SOFTWARE IS FOR GUIDANCE IN ORDER TO SAVE TIME. AS A RESULT, SINOWEALTH
  * SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES
  * WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT OF SUCH FIRMWARE AND/OR
  * THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN
  * CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2021 Sinowealth</center></h2>
  *
  *
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __SH30F9XX_SA0_RETARGET_H
#define __SH30F9XX_SA0_RETARGET_H

/* Includes ------------------------------------------------------------------*/
#include "sh30f9xx_sa0_libcfg.h"


#ifdef __cplusplus
 extern "C" {
#endif

/*****************************************************************************/
//-------- <<< Use Configuration Wizard in Context Menu >>> -----------------
/*****************************************************************************/
//<o> ģʽѡ
//   <0=> ITM_MODE
//   <1=> UART_MODE
#define  OUTPUT_MODE    1

#define  ITM_MODE       0
#define  UART_MODE      1


//<o> ITMƵ
#define  ITM_FREQ_DEFAULT    500000


//<o> UART
#define  UART_BAUD_DEFAULT   9600


//<o> UARTѡ
//   <0=> SEL_UART0
//   <1=> SEL_UART1
//   <2=> SEL_UART2
//   <3=> SEL_UART3
#define  Uart_Sel       2

#define  SEL_UART0      0
#define  SEL_UART1      1
#define  SEL_UART2      2
#define  SEL_UART3      3



// <h> UART REMAPѡ
// <o> UART0 REMAPѡ
//   <0=> SEL_REMAP0(PA15_TXD0,PB0_RXD0)
//   <1=> SEL_REMAP1(PB0_TXD0,PA15_RXD0)
//   <2=> SEL_REMAP2(PC3_TXD0,PC4_RXD0)
//   <3=> SEL_REMAP3(PC4_TXD0,PC3_RXD0)
//   <4=> SEL_REMAP4(PD0_TXD0,PD1_RXD0)
//   <5=> SEL_REMAP5(PD1_TXD0,PD0_RXD0)
#define  Uart0_Remap     0

// <o> UART1 REMAPѡ
//   <0=> SEL_REMAP0(PA9_TXD1,PA10_RXD1)
//   <1=> SEL_REMAP1(PA10_TXD1,PA9_RXD1)
//   <2=> SEL_REMAP2(PC8_TXD1,PC9_RXD1)
//   <3=> SEL_REMAP3(PC9_TXD1,PC8_RXD1)
//   <4=> SEL_REMAP4(PD2_TXD1,PD3_RXD1)
//   <5=> SEL_REMAP5(PD3_TXD1,PD2_RXD1)
#define  Uart1_Remap     0

// <o> UART2 REMAPѡ
//   <0=> SEL_REMAP0(PB12_TXD2,PC10_RXD2)
//   <1=> SEL_REMAP1(PB14_TXD2,PB13_RXD2)
//   <2=> SEL_REMAP2(PC10_TXD2,PB13_RXD2)
//   <3=> SEL_REMAP3(PD8_TXD2,PD7_RXD2)
//   <4=> SEL_REMAP4(PD10_TXD2,PD9_RXD2)
#define  Uart2_Remap     4

// <o> UART3 REMAPѡ
//   <0=> SEL_REMAP0(PB2_TXD3,PC5_RXD3)
//   <1=> SEL_REMAP1(PC5_TXD3,PC6_RXD3)
//   <2=> SEL_REMAP2(PC6_TXD3,PB3_RXD3)
//   <3=> SEL_REMAP3(PC7_TXD3,PB3_RXD3)
#define  Uart3_Remap     1

//</h>



/*****************************************************************************/
//-------- <<< end of configuration section >>> -----------------------------
/*****************************************************************************/
/** @addtogroup Retarget_Group
  * @{
  */

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/

/* Exported macro ------------------------------------------------------------*/


/** @addtogroup Retarget_Group_Pub_Funcs
  * @{
  */
/*! Retarget Init function */
void RetargetInit(void);

/*! flush printf buffer to output device */
void flush_printfbuffer(void);

/**
  * @}
  */


/**
  * @}
  */


#ifdef __cplusplus
}
#endif

#endif /*__SH30F9xx_SA0_RETARGET_H */



/************************ (C) COPYRIGHT Sinowealth ****************************/
/********************************END OF FILE***********************************/
