#ifndef __UART_H
#define __UART_H
#include <stdint.h>

#ifndef __IO
#define __IO    volatile
#endif

#define PC_ADJUST_TK      0x01
#define PC_ACK_TK         0x02
#define PC_REQ_FRE_SWITCH 0x07

#define FRAMEHEAD         0x69

typedef struct
{
    uint8_t ch_N;
    uint8_t Tx_Cnt;
    union
    {
        __IO uint8_t TkUartSendbuf[11];
        struct
        {
            __IO uint8_t TK_Framehead;
            __IO uint8_t TK_DataLen;
            __IO uint8_t TK_Command;
            __IO uint8_t TK_Data0;
            __IO uint8_t TK_Data1;
            __IO uint8_t TK_Data2;
            __IO uint8_t TK_Data3;
            __IO uint8_t TK_Data4;
            __IO uint8_t TK_Data5;
            __IO uint8_t TK_Data6;
            __IO uint8_t TK_Data7;
        } SByte;
    } Sbuf;
} TouchKey_Send_Typedef;
extern TouchKey_Send_Typedef TK_Send;

typedef struct
{
    __IO uint8_t gbUartTran;
    __IO uint8_t PC_Ack_Ok_flag;
    __IO uint8_t tk_div_conf_Tx_req;
    __IO uint8_t tk_max_diff_conf_Tx_req;
    __IO uint8_t tk_data_Tx_req;
    __IO uint8_t fre_switch_flag_uart;
    __IO uint8_t tk_status_Tx_req;
} UART_FLAG_Typedef;
extern UART_FLAG_Typedef uart_flag;

/*UARTʼ*/
void TkUartInit(void);

/*UARTʹֵͼֵ*/
void UartTxd(uint8_t parameter0, uint16_t parameter1);

/*У׼UARTʹ쳣״̬*/
void UartTxdStatus(uint8_t tkstatus);

/*ڷ´*/
void UartSendNewTkConfig(void);

#endif
