/**
 * @file      sino_uart.c
 * @brief     ݷʹáݷ
 * @author    xiong.zhang
 * @date      2022-03-15
 * @version   V1.2
 * @copyright Copyright (c) 1994 - 2022 ӱӹɷ޹˾
 *
 * @attention
 * Ӳƽ̨:
 * @par ޸־
 * <table>
 * <tr><th>Date        <th>Version  <th>Author    <th>Description
 * <tr><td>2021-12-10  <td>1.0      <td>bruce     <td>ʼ
 * <tr><td>2022-03-15  <td>1.2      <td>bruce     <td>޸Ĳʼλ,־λbit
 *                                                    ĻԭֽڷʽRead-Modify-Writeݲԣ 
 * <tr><td>2022-04-27  <td>1.3      <td>bruce     <td>ײӦò㣨ݴֿںάоƬͺţ
 * </table>
 */

#ifndef _RTE_
#include "../Inc/tk_include.h"

#ifdef _SH32F9B00
#    include "../Tk_sh32f9xx_sc0_bsp/tk_sh32f9xx_sc0_bsp.c"
#    include "../Tk_sh32f9xx_sc0_bsp/system_sh32f9xx_sc0.c"
#endif
#if (defined(_SH32F9061) || defined(_SH32F9062) || defined(_SH32F9861))
#    include "../Tk_sh32f9xx_sb0_bsp/tk_sh32f9xx_sb0_bsp.c"
#    include "../Tk_sh32f9xx_sb0_bsp/system_sh32f9xx_sb0.c"
#endif
#else
#include "tk_include.h"
#endif

#if EN_DATAADJUST

TouchKey_Send_Typedef TK_Send = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

UART_FLAG_Typedef uart_flag = {0, 0, 0, 0, 0, 0, 0};

/**
 * @brief     UARTʼ
 * @param     FrameParameter ṹָ
 * @return    null
 */
static void UartParameterInit(TouchKey_Send_Typedef *FrameParameter)
{
    FrameParameter->Sbuf.SByte.TK_Framehead = FRAMEHEAD;
#    if (!TOUCH_ADJUST)
    FrameParameter->Sbuf.SByte.TK_DataLen = 9;
    FrameParameter->Sbuf.SByte.TK_Command = 0x02;
    FrameParameter->Sbuf.SByte.TK_Data3   = 0x12;
#    endif
}

/**
 * @brief     UARTʼģ+
 * @param     null
 * @return    null
 */
void TkUartInit(void)
{
    UartParameterInit(&TK_Send);
    TK_Uart_Init();
}

/**
 * @brief     ݿλλ
 * @param     null
 * @return    null
 */
static void SendRest(void)
{
    TK_Send.ch_N         = 0;
    uart_flag.gbUartTran = 0;
}

#    if TOUCH_ADJUST
/**
 * @brief     У׼UARTʹ쳣״̬
 * @param     tkstatus    ״̬
 * @return    null
 */
void UartTxdStatus(uint8_t tkstatus)
{
    uart_flag.PC_Ack_Ok_flag = 0;
    while (uart_flag.gbUartTran)
        ;
    if (uart_flag.tk_status_Tx_req == 0)
    {
        uart_flag.tk_status_Tx_req = 1;
        UartTxd(tkstatus, 0);
    }
}

/**
 * @brief     uartݴ
 */
void UartReceDeal(uint8_t Rx_buf)
{
    static uint8_t Rx_Cnt     = 0;
    static uint8_t Rx_sum     = 0;
    static uint8_t PC_Command = 0;
    // Rx_buf = UART->RDR;
    Rx_Cnt++;
    switch (Rx_Cnt)
    {
        case 1:
            Rx_sum = Rx_buf;
            if (FRAMEHEAD != Rx_buf)
            {
                Rx_Cnt = 0;
            }
            break;
        case 2:
            Rx_sum += Rx_buf;
            if (0x03 != Rx_buf)
            {
                Rx_Cnt = 0;
            }
            break;
        case 3:
            Rx_sum += Rx_buf;
            if (0x41 != Rx_buf)
            {
                Rx_Cnt = 0;
            }
            break;
        case 4:
            Rx_sum += Rx_buf;
            PC_Command = Rx_buf;
            break;
        case 5:
            if (Rx_sum == Rx_buf)
            {
                if (PC_ADJUST_TK == PC_Command)
                {
                    tk_flag.tk_adjust_flag = ~tk_flag.tk_adjust_flag;
                }
                else if (PC_ACK_TK == PC_Command)
                {
                    uart_flag.PC_Ack_Ok_flag = 1;
                }
                else if (PC_REQ_FRE_SWITCH == PC_Command)
                {
                    uart_flag.fre_switch_flag_uart = 1;
                }
            }
            Rx_Cnt     = 0;
            PC_Command = 0;
            break;
        default:
            Rx_Cnt     = 0;
            PC_Command = 0;
            break;
    }
}

/**
 * @brief     uartݴ
 */
void UartSendDeal(void)
{
    if (TK_Send.Tx_Cnt == (TK_Send.Sbuf.SByte.TK_DataLen + 2))  //ÿ̶֡3֡ͷݳȡ++ЧλTK_DataLen
    {
        TK_Send.Tx_Cnt = 0;
        if ((1 == uart_flag.tk_status_Tx_req) || (1 == uart_flag.tk_div_conf_Tx_req))
        {
            SendRest();
            StopSend();
            if (1 == uart_flag.tk_status_Tx_req)
            {
                uart_flag.tk_status_Tx_req = 0;
            }
            else if (1 == uart_flag.tk_div_conf_Tx_req)
            {
                uart_flag.tk_div_conf_Tx_req = 0;
            }
        }
        else if ((1 == uart_flag.tk_max_diff_conf_Tx_req) || (1 == uart_flag.tk_data_Tx_req))
        {
            TK_Send.ch_N++;
            if (TK_Send.ch_N == tk_num)
            {
                SendRest();
                StopSend();
                if (1 == uart_flag.tk_max_diff_conf_Tx_req)
                {
                    uart_flag.tk_max_diff_conf_Tx_req = 0;
                }
            }
            else
            {
                TK_Send.Sbuf.SByte.TK_Data0 = TK_Send.ch_N;
                if (1 == uart_flag.tk_max_diff_conf_Tx_req)
                {
                    TK_Send.Sbuf.SByte.TK_Data1 = (uint8_t)(key_max_diff[TK_Send.ch_N] >> 8);
                    TK_Send.Sbuf.SByte.TK_Data2 = (uint8_t)(key_max_diff[TK_Send.ch_N]);
                }
                else if (1 == uart_flag.tk_data_Tx_req)
                {
                    TK_Send.Sbuf.SByte.TK_Data1 = (uint8_t)(LF_key_baseline[TK_Send.ch_N] >> 8);
                    TK_Send.Sbuf.SByte.TK_Data2 = (uint8_t)(LF_key_baseline[TK_Send.ch_N]);
                    TK_Send.Sbuf.SByte.TK_Data4 = TK_Send.ch_N;
                    TK_Send.Sbuf.SByte.TK_Data5 = (uint8_t)(LF_key[TK_Send.ch_N] >> 8);
                    TK_Send.Sbuf.SByte.TK_Data6 = (uint8_t)(LF_key[TK_Send.ch_N]);
                }
            }
        }
        else
        {
            uart_flag.gbUartTran = 0;
            StopSend();
        }
        TK_Send.Sbuf.TkUartSendbuf[TK_Send.Sbuf.SByte.TK_DataLen + 1] = 0;  //checksumֵ
    }
}

/**
 * @brief     У׼UARTʹֵͼֵ
 * @param     parameter0 ȡú
 * @param     parameter1 ȡú
 */
void UartTxd(uint8_t parameter0, uint16_t parameter1)
{
    if (0 == uart_flag.gbUartTran)
    {
        TK_Send.Tx_Cnt = 0;
        TK_Send.ch_N   = 0;
        if (1 == uart_flag.tk_status_Tx_req)
        {
            TK_Send.Sbuf.SByte.TK_DataLen = 4;
            TK_Send.Sbuf.SByte.TK_Command = 0x51;

            TK_Send.Sbuf.SByte.TK_Data0 = parameter0;
            TK_Send.Sbuf.SByte.TK_Data1 = TOUCHKEY->TKW;
            TK_Send.Sbuf.SByte.TK_Data2 = 0;  //λchecksum
        }
        else if (1 == uart_flag.tk_div_conf_Tx_req)
        {
            TK_Send.Sbuf.SByte.TK_DataLen = 5;
            TK_Send.Sbuf.SByte.TK_Command = 0x32;

            TK_Send.Sbuf.SByte.TK_Data0 = parameter0;
            TK_Send.Sbuf.SByte.TK_Data1 = (uint8_t)(parameter1 >> 8);
            TK_Send.Sbuf.SByte.TK_Data2 = (uint8_t)(parameter1);
            TK_Send.Sbuf.SByte.TK_Data3 = 0;  //λchecksum
        }
        else if (1 == uart_flag.tk_max_diff_conf_Tx_req)
        {
            TK_Send.Sbuf.SByte.TK_DataLen = 5;
            TK_Send.Sbuf.SByte.TK_Command = 0x22;
            TK_Send.Sbuf.SByte.TK_Data0   = TK_Send.ch_N;
            TK_Send.Sbuf.SByte.TK_Data1   = (uint8_t)(key_max_diff[TK_Send.ch_N] >> 8);
            TK_Send.Sbuf.SByte.TK_Data2   = (uint8_t)(key_max_diff[TK_Send.ch_N]);
            TK_Send.Sbuf.SByte.TK_Data3   = 0;  //λchecksum
        }
        else if (1 == uart_flag.tk_data_Tx_req)
        {
            TK_Send.Sbuf.SByte.TK_DataLen = 9;
            TK_Send.Sbuf.SByte.TK_Command = 0x02;
            TK_Send.Sbuf.SByte.TK_Data0   = TK_Send.ch_N;
            TK_Send.Sbuf.SByte.TK_Data1   = (uint8_t)(LF_key_baseline[TK_Send.ch_N] >> 8);
            TK_Send.Sbuf.SByte.TK_Data2   = (uint8_t)(LF_key_baseline[TK_Send.ch_N]);
            TK_Send.Sbuf.SByte.TK_Data3   = 0x12;
            TK_Send.Sbuf.SByte.TK_Data4   = TK_Send.ch_N;
            TK_Send.Sbuf.SByte.TK_Data5   = (uint8_t)(LF_key[TK_Send.ch_N] >> 8);
            TK_Send.Sbuf.SByte.TK_Data6   = (uint8_t)(LF_key[TK_Send.ch_N]);
            TK_Send.Sbuf.SByte.TK_Data7   = 0;  //λchecksum
        }
        uart_flag.gbUartTran = 1;
        StartSend();
    }
}
#    else
void UartSendDeal()
{
    if (TK_Send.Tx_Cnt ==
        (TK_Send.Sbuf.SByte.TK_DataLen + 2))  //ÿ̶֡3֡ͷݳȡ++ЧλTK_DataLen
    {
        TK_Send.Tx_Cnt = 0;
        TK_Send.ch_N++;
#        if (L_SEND < 5)
        if (TK_Send.ch_N == tk_num)
#        else
#            if (KEY_NUMBER1 > 12)
        if (TK_Send.ch_N == 24)
#            else
        if (TK_Send.ch_N == tk_num * 2)
#            endif
#        endif
        {
            SendRest();
            StopSend();
        }

        else
        {
            TK_Send.Sbuf.SByte.TK_Data0 = TK_Send.ch_N;
            TK_Send.Sbuf.SByte.TK_Data4 = TK_Send.ch_N;
#        if (1 == L_SEND)  //͵Ƶ ֵ+˲ֵ
            TK_Send.Sbuf.SByte.TK_Data1 = (uint8_t)(LF_key_baseline[TK_Send.ch_N] >> 8);
            TK_Send.Sbuf.SByte.TK_Data2 = (uint8_t)(LF_key_baseline[TK_Send.ch_N]);
            TK_Send.Sbuf.SByte.TK_Data5 = (uint8_t)(LF_key[TK_Send.ch_N] >> 8);
            TK_Send.Sbuf.SByte.TK_Data6 = (uint8_t)(LF_key[TK_Send.ch_N]);
#        endif
#        if (2 == L_SEND)  //͵Ƶ ֵ+޷ǰֵ
            TK_Send.Sbuf.SByte.TK_Data1 = (uint8_t)(LF_key_baseline[TK_Send.ch_N] >> 8);
            TK_Send.Sbuf.SByte.TK_Data2 = (uint8_t)(LF_key_baseline[TK_Send.ch_N]);
            TK_Send.Sbuf.SByte.TK_Data5 = (uint8_t)(LF_key_RAM[TK_Send.ch_N] >> 8);
            TK_Send.Sbuf.SByte.TK_Data6 = (uint8_t)(LF_key_RAM[TK_Send.ch_N]);
#        endif
#        if (3 == L_SEND)  //͸Ƶֵ+˲ֵ
            TK_Send.Sbuf.SByte.TK_Data1 = (uint8_t)(HF_key_baseline[TK_Send.ch_N] >> 8);
            TK_Send.Sbuf.SByte.TK_Data2 = (uint8_t)(HF_key_baseline[TK_Send.ch_N]);
            TK_Send.Sbuf.SByte.TK_Data5 = (uint8_t)(HF_key[TK_Send.ch_N] >> 8);
            TK_Send.Sbuf.SByte.TK_Data6 = (uint8_t)(HF_key[TK_Send.ch_N]);
#        endif
#        if (4 == L_SEND)  //͸Ƶֵ+޷ǰֵ
            TK_Send.Sbuf.SByte.TK_Data1 = (uint8_t)(HF_key_baseline[TK_Send.ch_N] >> 8);
            TK_Send.Sbuf.SByte.TK_Data2 = (uint8_t)(HF_key_baseline[TK_Send.ch_N]);
            TK_Send.Sbuf.SByte.TK_Data5 = (uint8_t)(HF_key_RAM[TK_Send.ch_N] >> 8);
            TK_Send.Sbuf.SByte.TK_Data6 = (uint8_t)(HF_key_RAM[TK_Send.ch_N]);
#        endif
#        if (5 == L_SEND)  //͸Ƶ/Ƶֵ+˲ֵ
            if (TK_Send.ch_N < tk_num)
            {
                TK_Send.Sbuf.SByte.TK_Data1 = (uint8_t)(HF_key_baseline[TK_Send.ch_N] >> 8);
                TK_Send.Sbuf.SByte.TK_Data2 = (uint8_t)(HF_key_baseline[TK_Send.ch_N]);
                TK_Send.Sbuf.SByte.TK_Data5 = (uint8_t)(HF_key[TK_Send.ch_N] >> 8);
                TK_Send.Sbuf.SByte.TK_Data6 = (uint8_t)(HF_key[TK_Send.ch_N]);
            }
            else
            {
                TK_Send.Sbuf.SByte.TK_Data1 = (uint8_t)(LF_key_baseline[TK_Send.ch_N - tk_num] >> 8);
                TK_Send.Sbuf.SByte.TK_Data2 = (uint8_t)(LF_key_baseline[TK_Send.ch_N - tk_num]);
                TK_Send.Sbuf.SByte.TK_Data5 = (uint8_t)(LF_key[TK_Send.ch_N - tk_num] >> 8);
                TK_Send.Sbuf.SByte.TK_Data6 = (uint8_t)(LF_key[TK_Send.ch_N - tk_num]);
            }
#        endif
#        if (6 == L_SEND)  //͸Ƶ+Ƶ +޷ǰֵ
            if (TK_Send.ch_N < tk_num)
            {
                TK_Send.Sbuf.SByte.TK_Data1 = (uint8_t)(HF_key_baseline[TK_Send.ch_N] >> 8);
                TK_Send.Sbuf.SByte.TK_Data2 = (uint8_t)(HF_key_baseline[TK_Send.ch_N]);
                TK_Send.Sbuf.SByte.TK_Data5 = (uint8_t)(HF_key_RAM[TK_Send.ch_N] >> 8);
                TK_Send.Sbuf.SByte.TK_Data6 = (uint8_t)(HF_key_RAM[TK_Send.ch_N]);
            }
            else
            {
                TK_Send.Sbuf.SByte.TK_Data1 = (uint8_t)(LF_key_baseline[TK_Send.ch_N - tk_num] >> 8);
                TK_Send.Sbuf.SByte.TK_Data2 = (uint8_t)(LF_key_baseline[TK_Send.ch_N - tk_num]);
                TK_Send.Sbuf.SByte.TK_Data5 = (uint8_t)(LF_key_RAM[TK_Send.ch_N - tk_num] >> 8);
                TK_Send.Sbuf.SByte.TK_Data6 = (uint8_t)(LF_key_RAM[TK_Send.ch_N - tk_num]);
            }
#        endif
        }
        TK_Send.Sbuf.TkUartSendbuf[TK_Send.Sbuf.SByte.TK_DataLen + 1] = 0;  //У0
    }
}
/**
 * @brief     UARTʹֵͼֵ
 * @param     parameter0 òΪ0
 * @param     parameter1 òΪ0
 */

void UartTxd(uint8_t parameter0, uint16_t parameter1)
{
    if (0 == uart_flag.gbUartTran)
    {
        TK_Send.Tx_Cnt              = 0;
        TK_Send.ch_N                = 0;
        TK_Send.Sbuf.SByte.TK_Data0 = TK_Send.ch_N;
        TK_Send.Sbuf.SByte.TK_Data4 = TK_Send.ch_N;
#        if (1 == L_SEND)  //͵Ƶ ֵ+˲ֵ
        TK_Send.Sbuf.SByte.TK_Data1 = (uint8_t)(LF_key_baseline[TK_Send.ch_N] >> 8);
        TK_Send.Sbuf.SByte.TK_Data2 = (uint8_t)(LF_key_baseline[TK_Send.ch_N]);
        TK_Send.Sbuf.SByte.TK_Data5 = (uint8_t)(LF_key[TK_Send.ch_N] >> 8);
        TK_Send.Sbuf.SByte.TK_Data6 = (uint8_t)(LF_key[TK_Send.ch_N]);
#        endif
#        if (2 == L_SEND)  //͵Ƶ ֵ+޷ǰֵ
        TK_Send.Sbuf.SByte.TK_Data1 = (uint8_t)(LF_key_baseline[TK_Send.ch_N] >> 8);
        TK_Send.Sbuf.SByte.TK_Data2 = (uint8_t)(LF_key_baseline[TK_Send.ch_N]);
        TK_Send.Sbuf.SByte.TK_Data5 = (uint8_t)(LF_key_RAM[TK_Send.ch_N] >> 8);
        TK_Send.Sbuf.SByte.TK_Data6 = (uint8_t)(LF_key_RAM[TK_Send.ch_N]);
#        endif
#        if (3 == L_SEND)  //͸Ƶֵ+˲ֵ
        TK_Send.Sbuf.SByte.TK_Data1 = (uint8_t)(HF_key_baseline[TK_Send.ch_N] >> 8);
        TK_Send.Sbuf.SByte.TK_Data2 = (uint8_t)(HF_key_baseline[TK_Send.ch_N]);
        TK_Send.Sbuf.SByte.TK_Data5 = (uint8_t)(HF_key[TK_Send.ch_N] >> 8);
        TK_Send.Sbuf.SByte.TK_Data6 = (uint8_t)(HF_key[TK_Send.ch_N]);
#        endif
#        if (4 == L_SEND)  //͸Ƶֵ+޷ǰֵ
        TK_Send.Sbuf.SByte.TK_Data1 = (uint8_t)(HF_key_baseline[TK_Send.ch_N] >> 8);
        TK_Send.Sbuf.SByte.TK_Data2 = (uint8_t)(HF_key_baseline[TK_Send.ch_N]);
        TK_Send.Sbuf.SByte.TK_Data5 = (uint8_t)(HF_key_RAM[TK_Send.ch_N] >> 8);
        TK_Send.Sbuf.SByte.TK_Data6 = (uint8_t)(HF_key_RAM[TK_Send.ch_N]);
#        endif
#        if (5 == L_SEND)  //͸Ƶ/Ƶֵ+˲ֵ
        TK_Send.Sbuf.SByte.TK_Data1 = (uint8_t)(HF_key_baseline[TK_Send.ch_N] >> 8);
        TK_Send.Sbuf.SByte.TK_Data2 = (uint8_t)(HF_key_baseline[TK_Send.ch_N]);
        TK_Send.Sbuf.SByte.TK_Data5 = (uint8_t)(HF_key[TK_Send.ch_N] >> 8);
        TK_Send.Sbuf.SByte.TK_Data6 = (uint8_t)(HF_key[TK_Send.ch_N]);
#        endif
#        if (6 == L_SEND)  //͸Ƶ/Ƶֵ+޷ǰֵ
        TK_Send.Sbuf.SByte.TK_Data1 = (uint8_t)(HF_key_baseline[TK_Send.ch_N] >> 8);
        TK_Send.Sbuf.SByte.TK_Data2 = (uint8_t)(HF_key_baseline[TK_Send.ch_N]);
        TK_Send.Sbuf.SByte.TK_Data5 = (uint8_t)(HF_key_RAM[TK_Send.ch_N] >> 8);
        TK_Send.Sbuf.SByte.TK_Data6 = (uint8_t)(HF_key_RAM[TK_Send.ch_N]);
#        endif

        TK_Send.Sbuf.TkUartSendbuf[TK_Send.Sbuf.SByte.TK_DataLen + 1] = 0;
        uart_flag.gbUartTran                                          = 1;
        StartSend();
    }
}
#    endif  // endif TOUCH_ADJUST line 58

/**
 * @brief     У׼UARTжϷ
 * @param     null
 * @return    null
 */
void UART_Handler()
{
    /*˱ΪIAR£volatileֵ*/
    static uint8_t checksum = 0;  
#    if TOUCH_ADJUST
    if (1 == UART->FR.BIT.RI)
    {
        UartReceDeal(UartReceByte());
    }
#    endif
    if (1 == UART->FR.BIT.TI)
    {
        UART->FR.BIT.TCC = 1;
        UartSendDeal();
        if (1 == uart_flag.gbUartTran)
        {
            UartSendByte(TK_Send.Sbuf.TkUartSendbuf[TK_Send.Tx_Cnt]);
            if (TK_Send.Tx_Cnt < (TK_Send.Sbuf.SByte.TK_DataLen + 1))
            {
                checksum += TK_Send.Sbuf.TkUartSendbuf[TK_Send.Tx_Cnt];
//                TK_Send.Sbuf.TkUartSendbuf[TK_Send.Sbuf.SByte.TK_DataLen + 1] +=
//                    TK_Send.Sbuf.TkUartSendbuf[TK_Send.Tx_Cnt];
            }
            if (TK_Send.Tx_Cnt == TK_Send.Sbuf.SByte.TK_DataLen)
            {
                TK_Send.Sbuf.TkUartSendbuf[TK_Send.Sbuf.SByte.TK_DataLen + 1] = checksum;   
                checksum = 0;
            }
            TK_Send.Tx_Cnt++;
        }
    }
}
#endif  // endif EN_DATAADJUST line 22
