/**
 * @file      sh32f9b00_uart_cfg.c
 * @brief
 * @author    sinowealth software group ()
 * @date      2022-04-27
 * @version   V1.0
 * @copyright Copyright (c) 1994 - 2022 ӱӹɷ޹˾
 *
 * @attention
 * Ӳƽ̨:
 * @par ޸־
 * <table>
 * <tr><th>Date        <th>Version  <th>Author    <th>Description
 * <tr><td>2022-04-27  <td>1.0      <td>bruce     <td>ʼ棬оƬͺ
 * </table>
 */
#ifndef _RTE_
#include "../Inc/tk_include.h"
#else
#include "tk_include.h"
#endif
/**
 * @brief     رTouchKey
 * @param     null
 * @return    null
 */
void DisTk(void)
{
    TOUCHKEY->TKU[0]      = 0;
    TOUCHKEY->TKU[1]      = 0;
    TOUCHKEY->TKU[2]      = 0;
    TOUCHKEY->TKCHANEL[0] = 0;
    TOUCHKEY->TKCHANEL[1] = 0;
    TOUCHKEY->TKCHANEL[2] = 0;
}
/**
 * @brief     ɨŵ
 * @param     n         ͨ
 * @return    null
 */
void EnTk(uint8_t n)
{
    switch (n)
    {
        case 0:  GPIOC_CFG->AFRL.BIT.AFR0  = 10;  TOUCHKEY->TKU[0] = BIT0;  TOUCHKEY->TKCHANEL[0] = BIT0;  break;
        case 1:  GPIOC_CFG->AFRL.BIT.AFR1  = 10;  TOUCHKEY->TKU[0] = BIT1;  TOUCHKEY->TKCHANEL[0] = BIT1;  break;
        case 2:  GPIOC_CFG->AFRL.BIT.AFR2  = 10;  TOUCHKEY->TKU[0] = BIT2;  TOUCHKEY->TKCHANEL[0] = BIT2;  break;
        case 3:  GPIOC_CFG->AFRL.BIT.AFR3  = 10;  TOUCHKEY->TKU[0] = BIT3;  TOUCHKEY->TKCHANEL[0] = BIT3;  break;
        case 4:  GPIOC_CFG->AFRL.BIT.AFR4  = 10;  TOUCHKEY->TKU[0] = BIT4;  TOUCHKEY->TKCHANEL[0] = BIT4;  break;
        case 5:  GPIOC_CFG->AFRL.BIT.AFR5  = 10;  TOUCHKEY->TKU[0] = BIT5;  TOUCHKEY->TKCHANEL[0] = BIT5;  break;
        case 6:  GPIOC_CFG->AFRL.BIT.AFR6  = 10;  TOUCHKEY->TKU[0] = BIT6;  TOUCHKEY->TKCHANEL[0] = BIT6;  break;
        case 7:  GPIOC_CFG->AFRL.BIT.AFR7  = 10;  TOUCHKEY->TKU[0] = BIT7;  TOUCHKEY->TKCHANEL[0] = BIT7;  break;
        case 8:  GPIOC_CFG->AFRH.BIT.AFR8  = 10;  TOUCHKEY->TKU[1] = BIT0;  TOUCHKEY->TKCHANEL[1] = BIT0;  break;
        case 9:  GPIOC_CFG->AFRH.BIT.AFR9  = 10;  TOUCHKEY->TKU[1] = BIT1;  TOUCHKEY->TKCHANEL[1] = BIT1;  break;
        case 10: GPIOC_CFG->AFRH.BIT.AFR10 = 10;  TOUCHKEY->TKU[1] = BIT2;  TOUCHKEY->TKCHANEL[1] = BIT2;  break;
        case 11: GPIOC_CFG->AFRH.BIT.AFR11 = 10;  TOUCHKEY->TKU[1] = BIT3;  TOUCHKEY->TKCHANEL[1] = BIT3;  break;
        case 12: GPIOC_CFG->AFRH.BIT.AFR13 = 10;  TOUCHKEY->TKU[1] = BIT4;  TOUCHKEY->TKCHANEL[1] = BIT4;  break;
        case 13: GPIOC_CFG->AFRH.BIT.AFR14 = 10;  TOUCHKEY->TKU[1] = BIT5;  TOUCHKEY->TKCHANEL[1] = BIT5;  break;
        case 14: GPIOC_CFG->AFRH.BIT.AFR15 = 10;  TOUCHKEY->TKU[1] = BIT6;  TOUCHKEY->TKCHANEL[1] = BIT6;  break;
        case 15: GPIOD_CFG->AFRL.BIT.AFR0  = 10;  TOUCHKEY->TKU[1] = BIT7;  TOUCHKEY->TKCHANEL[1] = BIT7;  break;
        case 16: GPIOD_CFG->AFRL.BIT.AFR1  = 10;  TOUCHKEY->TKU[2] = BIT0;  TOUCHKEY->TKCHANEL[2] = BIT0;  break;
        case 17: GPIOD_CFG->AFRL.BIT.AFR2  = 10;  TOUCHKEY->TKU[2] = BIT1;  TOUCHKEY->TKCHANEL[2] = BIT1;  break;
        case 18: GPIOD_CFG->AFRL.BIT.AFR3  = 10;  TOUCHKEY->TKU[2] = BIT2;  TOUCHKEY->TKCHANEL[2] = BIT2;  break;
        case 19: GPIOD_CFG->AFRL.BIT.AFR4  = 10;  TOUCHKEY->TKU[2] = BIT3;  TOUCHKEY->TKCHANEL[2] = BIT3;  break;
        case 20: GPIOD_CFG->AFRL.BIT.AFR5  = 10;  TOUCHKEY->TKU[2] = BIT4;  TOUCHKEY->TKCHANEL[2] = BIT4;  break;
        case 21: GPIOD_CFG->AFRL.BIT.AFR6  = 10;  TOUCHKEY->TKU[2] = BIT5;  TOUCHKEY->TKCHANEL[2] = BIT5;  break;
        case 22: GPIOD_CFG->AFRL.BIT.AFR7  = 10;  TOUCHKEY->TKU[2] = BIT6;  TOUCHKEY->TKCHANEL[2] = BIT6;  break;
        case 23: GPIOD_CFG->AFRH.BIT.AFR8  = 10;  TOUCHKEY->TKU[2] = BIT7;  TOUCHKEY->TKCHANEL[2] = BIT7;  break;
        default: break;
    }
}

/**
 * @brief     ɨŵIO
 * @param     n         ͨ
 * @return    null
 */
void EnIO(uint8_t n)
{
    switch (n)
    {
        case 0:  GPIOC_CFG->AFRL.BIT.AFR0  = 1;  GPIOC->MODER |= BIT0;  GPIOC->BSRR.BIT.BR = BIT0;  break;
        case 1:  GPIOC_CFG->AFRL.BIT.AFR1  = 1;  GPIOC->MODER |= BIT1;  GPIOC->BSRR.BIT.BR = BIT1;  break;
        case 2:  GPIOC_CFG->AFRL.BIT.AFR2  = 1;  GPIOC->MODER |= BIT2;  GPIOC->BSRR.BIT.BR = BIT2;  break;
        case 3:  GPIOC_CFG->AFRL.BIT.AFR3  = 1;  GPIOC->MODER |= BIT3;  GPIOC->BSRR.BIT.BR = BIT3;  break;
        case 4:  GPIOC_CFG->AFRL.BIT.AFR4  = 1;  GPIOC->MODER |= BIT4;  GPIOC->BSRR.BIT.BR = BIT4;  break;
        case 5:  GPIOC_CFG->AFRL.BIT.AFR5  = 1;  GPIOC->MODER |= BIT5;  GPIOC->BSRR.BIT.BR = BIT5;  break;
        case 6:  GPIOC_CFG->AFRL.BIT.AFR6  = 1;  GPIOC->MODER |= BIT6;  GPIOC->BSRR.BIT.BR = BIT6;  break;
        case 7:  GPIOC_CFG->AFRL.BIT.AFR7  = 1;  GPIOC->MODER |= BIT7;  GPIOC->BSRR.BIT.BR = BIT7;  break;
        case 8:  GPIOC_CFG->AFRH.BIT.AFR8  = 1;  GPIOC->MODER |= BIT8;  GPIOC->BSRR.BIT.BR = BIT8;  break;
        case 9:  GPIOC_CFG->AFRH.BIT.AFR9  = 1;  GPIOC->MODER |= BIT9;  GPIOC->BSRR.BIT.BR = BIT9;  break;
        case 10: GPIOC_CFG->AFRH.BIT.AFR10 = 1;  GPIOC->MODER |= BIT10; GPIOC->BSRR.BIT.BR = BIT10; break;
        case 11: GPIOC_CFG->AFRH.BIT.AFR11 = 1;  GPIOC->MODER |= BIT11; GPIOC->BSRR.BIT.BR = BIT11; break;
        case 12: GPIOC_CFG->AFRH.BIT.AFR13 = 1;  GPIOC->MODER |= BIT13; GPIOC->BSRR.BIT.BR = BIT13; break;
        case 13: GPIOC_CFG->AFRH.BIT.AFR14 = 1;  GPIOC->MODER |= BIT14; GPIOC->BSRR.BIT.BR = BIT14; break;
        case 14: GPIOC_CFG->AFRH.BIT.AFR15 = 1;  GPIOC->MODER |= BIT15; GPIOC->BSRR.BIT.BR = BIT15; break;
        case 15: GPIOD_CFG->AFRL.BIT.AFR0  = 1;  GPIOD->MODER |= BIT0;  GPIOD->BSRR.BIT.BR = BIT0;  break;
        case 16: GPIOD_CFG->AFRL.BIT.AFR1  = 1;  GPIOD->MODER |= BIT1;  GPIOD->BSRR.BIT.BR = BIT1;  break;
        case 17: GPIOD_CFG->AFRL.BIT.AFR2  = 1;  GPIOD->MODER |= BIT2;  GPIOD->BSRR.BIT.BR = BIT2;  break;
        case 18: GPIOD_CFG->AFRL.BIT.AFR3  = 1;  GPIOD->MODER |= BIT3;  GPIOD->BSRR.BIT.BR = BIT3;  break;
        case 19: GPIOD_CFG->AFRL.BIT.AFR4  = 1;  GPIOD->MODER |= BIT4;  GPIOD->BSRR.BIT.BR = BIT4;  break;
        case 20: GPIOD_CFG->AFRL.BIT.AFR5  = 1;  GPIOD->MODER |= BIT5;  GPIOD->BSRR.BIT.BR = BIT5;  break;
        case 21: GPIOD_CFG->AFRL.BIT.AFR6  = 1;  GPIOD->MODER |= BIT6;  GPIOD->BSRR.BIT.BR = BIT6;  break;
        case 22: GPIOD_CFG->AFRL.BIT.AFR7  = 1;  GPIOD->MODER |= BIT7;  GPIOD->BSRR.BIT.BR = BIT7;  break;
        case 23: GPIOD_CFG->AFRH.BIT.AFR8  = 1;  GPIOD->MODER |= BIT8;  GPIOD->BSRR.BIT.BR = BIT8;  break;
        default: break;
    }
}

/**
 * @brief     Get the Touch Sample Data object
 * @param     channel   ͨ
 * @return    null
 */
uint16_t GetTouchSampleData(uint8_t channel)
{
    static uint8_t  k    = 0;
    static uint16_t ret  = 0;
    static uint32_t Addr = 0;

    k = (Tab_Chn[channel] << 1);  //ֵ16λռֵַͨڵַΪn-1)*2+p (nʾͨpʾʼַ
    if (0 == (Tab_Chn[channel] % 2))
    {
        Addr = R_DATA_RAM_ADDR + 2;
    }
    else
    {
        Addr = R_DATA_RAM_ADDR;
        k    = k - 2;
    }
    ret = (*(volatile uint16_t *)(Addr + k));
    return ret;
}

/**
 * @brief     Timer ʱʼ
 * @param     null
 * @return    null
 */
void TimerInit(void)
{
    static uint32_t pclk0Freq = 0;
    uint16_t        TPRVALUE  = 0;

    SystemCoreClockUpdate();
    pclk0Freq = (SystemCoreClock >> ((RCC->CFGR.BIT.PPRE0 > 4) ? 4 : (RCC->CFGR.BIT.PPRE0)));
    TPRVALUE  = (uint16_t)(SYS_BASE_TIME * pclk0Freq / (PRESCALE + 1) / 1000);
    
    TIMER_CLOCK_ON();
    
    TIM->CR.V32    = 0;
    TIM->PSQ       = PRESCALE;
    TIM->TCNT      = 0x0000;
    TIM->TPR       = TPRVALUE;
    TIM->CR.BIT.IE = 1;
    NVIC_EnableIRQ((IRQn_Type)TIM_IRQ);
    TIM->CR.BIT.STR = 1;
}

uint8_t f_5ms  = 0;
uint8_t f_30ms = 0;

/**
 * @brief     Timerжϴ
 * @param     null
 * @return    null
 */
void TIM_Handler()
{
    static uint8_t T30msCnt = 0;
    TIM->TIMINTF.BIT.TFC    = 1;
    f_5ms                   = 1;
    if (++T30msCnt >= 6)
    {
        T30msCnt = 0;
        f_30ms   = 1;
    }
}

#if EN_DATAADJUST
#    if TOUCH_ADJUST
/**
 * @brief     UARTһByte
 * @return    UART
 */
uint8_t UartReceByte(void)
{
    return (UART->RDR);
}
#    endif
/**
 * @brief     UARTһByte
 * @param     TempValue UartҪ͵
 * @return    null
 */
void UartSendByte(uint8_t TempValue)
{
    UART->TDR = TempValue;
}

/**
 * @brief     ڷ
 * @param     null
 * @return    null
 */
void StartSend(void)
{
    UART->CR.BIT.TIE = 1;
}

/**
 * @brief     ֹͣڷ
 * @param     null
 * @return    null
 */
void StopSend(void)
{
    UART->CR.BIT.TIE = 0;
}

/**
 * @brief     UARTʼ
 * @param     null
 * @return    null
 * @note      115200ʣ1λʼλ1λֹͣλ
 */
void TK_Uart_Init(void)
{
    static uint32_t pclk0Freq  = 0;
    uint16_t        SBRTVALUE  = 0;
    uint8_t         BFINEVALUE = 0;

    GPIO_CLK_ON();
    /***********UARTܽ*****************/
#    if (0 == UART_SELECT)
    switch (UART0_PIN & 0xF0)
    {
        case 0x00: GPIOA_CFG->AFRL.BIT.AFR3 = 2; break;   // TXD PA3
        case 0x10: GPIOB_CFG->AFRL.BIT.AFR6 = 2; break;   // TXD PB6
        case 0x20: GPIOC_CFG->AFRH.BIT.AFR11 = 2; break;  // TXD PC11
        case 0x30: GPIOD_CFG->AFRH.BIT.AFR14 = 2; break;  // TXD PD14
        default: break;
    }
#        if TOUCH_ADJUST
    switch (UART0_PIN & 0x0F)
    {
        case 0x00:
            SYSCFG->SAFR.V32         = 0X5AA50020;
            GPIOA_CFG->AFRL.BIT.AFR4 = 2;
            break;                                        // RXD PA4
        case 0x01: GPIOB_CFG->AFRL.BIT.AFR7 = 2; break;   // RXD PB7
        case 0x02: GPIOC_CFG->AFRH.BIT.AFR10 = 2; break;  // RXD PC10
        case 0x03:
            GPIOD_CFG->PUPDR.BIT.PHDR13 = 1;
            GPIOD_CFG->AFRH.BIT.AFR13   = 2;
            break;  // RXD PD13
        default: break;
    }
#        endif  // endif TOUCH_ADJUST
#    endif      // endif (0 == UART_SELECT)
#    if (1 == UART_SELECT)
    switch (UART1_PIN & 0xF0)
    {
        case 0x00:
            SYSCFG->SAFR.V32         = 0X5AA50020;
            GPIOA_CFG->AFRL.BIT.AFR5 = 2;
            break;                                        // TXD1 PA5
        case 0x10: GPIOB_CFG->AFRH.BIT.AFR8 = 2; break;   // TXD1 PB8
        case 0x20: GPIOC_CFG->AFRL.BIT.AFR7 = 2; break;   // TXD1 PC7
        case 0x30: GPIOC_CFG->AFRH.BIT.AFR12 = 2; break;  // TXD1 PC12
        case 0x40: GPIOD_CFG->AFRH.BIT.AFR15 = 2; break;  // TXD1 PD15
        default: break;
    }
#        if TOUCH_ADJUST
    switch (UART1_PIN & 0x0F)
    {
        case 0x00: 
            SYSCFG->SAFR.V32         = 0X5AA50020;
            GPIOA_CFG->AFRL.BIT.AFR6 = 2; 
            break;                                        // RXD1 PA6
        case 0x01: GPIOB_CFG->AFRH.BIT.AFR9 = 2; break;   // RXD1 PB9
        case 0x02: GPIOC_CFG->AFRH.BIT.AFR8 = 2; break;   // RXD1 PC8
        case 0x03: GPIOC_CFG->AFRH.BIT.AFR13 = 2; break;  // RXD1 PC13
        case 0x04: GPIOE_CFG->AFRL.BIT.AFR0 = 2; break;   // RXD1 PE0
        default: break;
    }
#        endif  // endif TOUCH_ADJUST
#    endif      // endif (1 == UART_SELECT)

#    if (2 == UART_SELECT)
    switch (UART2_PIN & 0xF0)
    {
        case 0x00: GPIOA_CFG->AFRL.BIT.AFR7 = 2; break;   // TXD2 PA7
        case 0x10: GPIOB_CFG->AFRH.BIT.AFR10 = 2; break;  // TXD2 PB10
        case 0x20: GPIOC_CFG->AFRH.BIT.AFR14 = 2; break;  // TXD2 PC14
        case 0x30: GPIOE_CFG->AFRL.BIT.AFR1 = 2; break;   // TXD2 PE1
        case 0x40: GPIOE_CFG->AFRL.BIT.AFR5 = 2; break;   // TXD2 PE5
        default: break;
    }
#        if TOUCH_ADJUST
    switch (UART2_PIN & 0x0F)
    {
        case 0x00: GPIOA_CFG->AFRH.BIT.AFR8 = 2; break;   // RXD2 PA8
        case 0x01: GPIOB_CFG->AFRH.BIT.AFR11 = 2; break;  // RXD2 PB11
        case 0x02: GPIOC_CFG->AFRH.BIT.AFR15 = 2; break;  // RXD2 PC15
        case 0x03: GPIOE_CFG->AFRL.BIT.AFR2 = 2; break;   // RXD2 PE2
        case 0x04: GPIOE_CFG->AFRL.BIT.AFR6 = 2; break;   // RXD2 PE6
        default: break;
    }
#        endif  // endif TOUCH_ADJUST
#    endif      // endif (2 == UART_SELECT)

#    if (3 == UART_SELECT)
    //-------UART3 Port-------
    switch (UART3_PIN & 0xF0)
    {
        case 0x00: GPIOA_CFG->AFRL.BIT.AFR0 = 2; break;  // TXD3 PA0
        case 0x10: GPIOB_CFG->AFRL.BIT.AFR0 = 2; break;  // TXD3 PB0
        case 0x20: GPIOC_CFG->AFRL.BIT.AFR0 = 2; break;  // TXD3 PC0
        case 0x30: GPIOD_CFG->AFRL.BIT.AFR0 = 2; break;  // TXD2 PD0
        default: break;
    }
#        if TOUCH_ADJUST
    switch (UART3_PIN & 0x0F)
    {
        case 0x00: GPIOA_CFG->AFRL.BIT.AFR1 = 2; break;  // RXD3 PA1
        case 0x01: GPIOB_CFG->AFRL.BIT.AFR1 = 2; break;  // RXD3 PB1
        case 0x02: GPIOC_CFG->AFRL.BIT.AFR1 = 2; break;  // RXD3 PC1
        case 0x03: GPIOD_CFG->AFRL.BIT.AFR1 = 2; break;  // RXD3 PD1
        default: break;
    }
#        endif  // endif TOUCH_ADJUST
#    endif      // endif (3 == UART_SELECT)

#    if (4 == UART_SELECT)
    //-------UART4 Port-------
    switch (UART4_PIN & 0xF0)
    {
        case 0x00: GPIOA_CFG->AFRH.BIT.AFR9 = 2; break;  // TXD2 PA9
        case 0x10: GPIOB_CFG->AFRL.BIT.AFR2 = 2; break;  // TXD2 PB2
        case 0x20: GPIOC_CFG->AFRL.BIT.AFR2 = 2; break;  // TXD2 PC2
        case 0x30: GPIOD_CFG->AFRL.BIT.AFR2 = 2; break;  // TXD2 PD2
        default: break;
    }
#        if TOUCH_ADJUST
    switch (UART4_PIN & 0x0F)
    {
        case 0x00: GPIOA_CFG->AFRH.BIT.AFR10 = 2; break;  // RXD2 PA10
        case 0x01: GPIOB_CFG->AFRL.BIT.AFR3 = 2; break;   // RXD2 PB3
        case 0x02: GPIOC_CFG->AFRL.BIT.AFR3 = 2; break;   // RXD2 PC3
        case 0x03: GPIOD_CFG->AFRL.BIT.AFR3 = 2; break;   // RXD2 PD3
        default: break;
    }
#        endif  // endif TOUCH_ADJUST
#    endif      // endif (4 == UART_SELECT)

#    if (5 == UART_SELECT)
    //-------UART5 Port-------
    switch (UART5_PIN & 0xF0)
    {
        case 0x00: GPIOA_CFG->AFRH.BIT.AFR11 = 2; break;  // TXD5 PA11
        case 0x10: GPIOB_CFG->AFRL.BIT.AFR4 = 2; break;   // TXD5 PB4
        case 0x20: GPIOC_CFG->AFRL.BIT.AFR4 = 2; break;   // TXD5 PC4
        case 0x30: GPIOD_CFG->AFRL.BIT.AFR4 = 2; break;   // TXD5 PD4
        default: break;
    }
#        if TOUCH_ADJUST
    switch (UART5_PIN & 0x0F)
    {
        case 0x00: GPIOA_CFG->AFRH.BIT.AFR12 = 2; break;  // RXD2 PA12
        case 0x01: GPIOB_CFG->AFRL.BIT.AFR5 = 2; break;   // RXD2 PB5
        case 0x02: GPIOC_CFG->AFRL.BIT.AFR5 = 2; break;   // RXD2 PC5
        case 0x03: GPIOD_CFG->AFRL.BIT.AFR5 = 2; break;   // RXD2 PD5
        default: break;
    }
#        endif  // endif TOUCH_ADJUST
#    endif      // endif (5 == UART_SELECT)

    /***********UARTʱ*****************/
    RCC->RCCLOCK = 0x33CC;
#    if (0 == UART_SELECT)
    RCC->APB1ENR.BIT.UART0EN = 1;
#    elif (1 == UART_SELECT)
    RCC->APB1ENR.BIT.UART1EN = 1;
#    elif (2 == UART_SELECT)
    RCC->APB1ENR.BIT.UART2EN = 1;
#    elif (3 == UART_SELECT)
    RCC->APB1ENR.BIT.UART3EN = 1;
#    elif (4 == UART_SELECT)
    RCC->APB1ENR.BIT.UART4EN = 1;
#    elif (5 == UART_SELECT)
    RCC->APB1ENR.BIT.UART5EN = 1;
#    endif
    RCC->RCCLOCK = 0;
    SystemCoreClockUpdate();
    pclk0Freq  = (SystemCoreClock >> (RCC->CFGR.BIT.PPRE0 > 4 ? 4 : (RCC->CFGR.BIT.PPRE0)));
    SBRTVALUE  = (uint16_t)(pclk0Freq / 16 / TK_BAUDRATE - 1);
    BFINEVALUE = (uint8_t)((pclk0Freq / TK_BAUDRATE) - ((SBRTVALUE + 1) * 16));

    UART->CR.BIT.TEN    = 1;
    UART->CR.BIT.SM     = 1;
    UART->BRT.BIT.SBRT  = SBRTVALUE;
    UART->BRT.BIT.BFINE = BFINEVALUE;
    UART->CR.BIT.SBRTEN = 1;
#    if TOUCH_ADJUST
    UART->CR.BIT.REN = 1;
#    else
    UART->CR.BIT.REN = 0;
#    endif
#    if (L_SEND != 7 || TOUCH_ADJUST)
    UART->CR.BIT.RIE = 1;  //ʹܽж
#    endif
    UART->FR.BIT.RIC = 1;
    //    UartParameterInit(&TK_Send);
    NVIC_EnableIRQ((IRQn_Type)UART_IRQ);  //uartж
}
#endif
