#ifndef __TK_SH32F9xxx_SC0_BSP_H
#define __TK_SH32F9xxx_SC0_BSP_H

#include <sh32f9xx_sc0.h>

/*******************************UART macro definition**************************************/
//-------------- <<< Use Configuration Wizard in Context Menu >>> --------------
//    <o0>Baud Rate Select
//    <i>ѡ
//    <0=>115200 <1=>9600 <2=>4800 <3=>2400
//    <o1>Select UART <0=>EUART0 <1=>EUART1 <2=>EUART2 <3=>EUART3 <4=>EUART4 <5=>EUART5
//    <i>ѡUARTӿ
//    <h>UART0 Pin Select
//      <o2.4..5>TXD0 <0=>PA2 <1=>PB6 <2=>PC11 <3=>PD14 
//      <o2.0..1>RXD0 <0=>PA3 <1=>PB7 <2=>PC10 
//    </h>
//    <h>UART1 Pin Select
//    <o3.4..6>TXD1 <0=>PA4 <1=>PB8 <2=>PC7 <3=>PC12 <4=>PD15  
//    <o3.0..2>RXD1 <0=>PA5 <1=>PB9 <2=>PC8 <3=>PC13 <4=>PE0 
//    </h>
//    <h>UART2 Pin Select
//    <o4.4..7>TXD2 <0=>PA6 <1=>PB10 <2=>PC14 <3=>PE1 <4=>PE5
//    <o4.0..2>RXD2 <0=>PA7 <1=>PB11 <2=>PC15 <3=>PE2 <4=>PE6
//    </h>
//    <h>UART3 Pin Select
//    <o5.4..5>TXD3 <0=>PA0 <1=>PB0 <2=>PC0 <3=>PD0
//    <o5.0..1>RXD3 <0=>PA1 <1=>PB1 <2=>PC1 <3=>PD1
//    </h>
//    <h>UART4 Pin Select
//    <o6.4..5>TXD4 <0=>PA8 <1=>PB2 <2=>PC2 <3=>PD2 
//    <o6.0..1>RXD4 <0=>PA9 <1=>PB3 <2=>PC3 <3=>PD3
//    </h>
//    <h>UART5 Pin Select
//    <o7.4..5>TXD5 <0=>PA10 <1=>PB4 <2=>PC4 <3=>PD4
//    <o7.0..1>RXD5 <0=>PA11 <1=>PB5 <2=>PC5 <3=>PD5
//    </h>
/***************************Դڲ*****************************/
#define BAUDRATE_SEL            0      //

//UARTѡ
#define UART_SELECT             0      //0 -->UART0
                                       //1 -->UART1  
                                       //2 -->UART2
                                       //3 -->UART3  
                                       //4 -->UART4
                                       //5 -->UART5                               
//UARTѡ 
#define UART0_PIN               0x11   //UART0λѡ
#define UART1_PIN               0x44   //UART1λѡ 
#define UART2_PIN               0x44   //UART2λѡ
#define UART3_PIN               0x01   //UART3λѡ
#define UART4_PIN               0x33   //UART4λѡ
#define UART5_PIN               0x00   //UART5λѡ
//-------------------- <<< end of configuration section >>> --------------------

#if (0 == BAUDRATE_SEL) 
#define TK_BAUDRATE             (uint32_t)115200 //
#elif (1 == BAUDRATE_SEL) 
#define TK_BAUDRATE             (uint32_t)9600 //
#elif (2 == BAUDRATE_SEL) 
#define TK_BAUDRATE             (uint32_t)4800 //
#elif (3 == BAUDRATE_SEL) 
#define TK_BAUDRATE             (uint32_t)2400 //
#endif

#if (0 == UART_SELECT)
#define UART UART0
#define UART_IRQ 24
#define UART_Handler() UART0_Handler()

#elif (1 == UART_SELECT)
#define UART UART1
#define UART_IRQ 29
#define UART_Handler() UART1_Handler()

#elif (2 == UART_SELECT)
#define UART UART2
#define UART_IRQ 30
#define UART_Handler() UART2_Handler()

#elif (3 == UART_SELECT)
#define UART UART3
#define UART_IRQ 31
#define UART_Handler() UART3_Handler()

#elif (4 == UART_SELECT)
#define UART UART4
#define UART_IRQ 32
#define UART_Handler() UART4_Handler()

#elif (5 == UART_SELECT)
#define UART UART5
#define UART_IRQ 33
#define UART_Handler() UART5_Handler()

#endif

/******************************IWDT macro definition***************************************/
#define RST_WDT()                   {IWDT->CLR = 0xAAAA;}    /*ι*/

/******************************GPIO macro definition***************************************/
#define GPIO_CLK_ON()               {                                    \
                                        RCC->RCCLOCK = 0x33CC;           \
                                        RCC->AHBENR.BIT.GPIOEN = 1;     \
                                        RCC->RCCLOCK            = 0;     \
                                    }
                                    
/******************************TouchKey macro definition***********************************/
#define TOUCHKEY_CLK_ON()           {                                   \
                                        APB0_CFG->RCCLOCK = 0x33CC;     \
                                        APB0_CFG->APB0ENR.BIT.TKEN = 1; \
                                        APB0_CFG->RCCLOCK = 0;          \
                                    }

#define ENABLE_TOUCH()              TOUCHKEY->CR.BIT.TKCON = 1;
#define DISABLE_TK()                TOUCHKEY->CR.BIT.TKCON = 0;
                                    
#define ENABLE_TK_BG()              TOUCHKEY->CR.BIT.TK_BG = 1;
#define DISABLE_TK_BG()             TOUCHKEY->CR.BIT.TK_BG = 0;
                                    
// #define TkStart()                     TOUCHKEY->CR.BIT.TKGO_DONE=1;
                                    
#define TK_MD_SEL_CNT()             TOUCHKEY->CR.BIT.MODE =0;
#define TK_MD_SEL_TIME()            TOUCHKEY->CR.BIT.MODE =1;
                                    
#define TK_SAMP_SEL_1CNT()          TOUCHKEY->CR.BIT.FSW=0;
#define TK_SAMP_SEL_3CNT()          TOUCHKEY->CR.BIT.FSW=1;
#define TK_SAMP_SEL_6CNT()          TOUCHKEY->CR.BIT.FSW=2;
#define TK_SAMP_SEL_10CNT()         TOUCHKEY->CR.BIT.FSW=3;
                                    
#define EN_TK_FREQ_RANDOM()         TOUCHKEY->CR.BIT.TKRANDOM = 1;
#define DIS_TK_FREQ_RANDOM()        TOUCHKEY->CR.BIT.TKRANDOM = 0;
                                    
#define EN_TK_COMPENSATE()          TOUCHKEY->CR.BIT.TKOFFSET = 1;
#define DIS_TK_COMPENSATE()         TOUCHKEY->CR.BIT.TKOFFSET = 0;
                                    
#define EN_TK_TKOSM()               TOUCHKEY->CR.BIT.TKOSM = 1;  
#define TK_TKHYSW_OFF()             TOUCHKEY->CR.BIT.TKHYSW = 0;   
                                    
#define TK_TKHYSW_ON()              TOUCHKEY->CR.BIT.TKHYSW = 1;
#define TK_FRE_RDM_OFFSET1()        TOUCHKEY->CR.BIT.RANDOM = 0;
#define TK_FRE_RDM_OFFSET2()        TOUCHKEY->CR.BIT.RANDOM = 1;
#define TK_FRE_RDM_OFFSET3()        TOUCHKEY->CR.BIT.RANDOM = 2;
#define TK_FRE_RDM_OFFSET4()        TOUCHKEY->CR.BIT.RANDOM = 3;
                                    
#define TK_VDD_CHOSE()              TOUCHKEY->CR1.BIT.VSYSEN = 0;
#define TK_LDO_CHOSE()              TOUCHKEY->CR1.BIT.VSYSEN = 1;
                                    
#define TK_LDO_3P6V()               TOUCHKEY->CR1.BIT.VSYS = 0;
#define TK_LDO_3P2V()               TOUCHKEY->CR1.BIT.VSYS = 1;
#define TK_LDO_2P8V()               TOUCHKEY->CR1.BIT.VSYS = 2;
#define TK_LDO_2P4V()               TOUCHKEY->CR1.BIT.VSYS = 3;
                                    
#define TK_DATA_IS_OVER             TOUCHKEY->FR.BIT.IFERR == 1
#define TK_GO_IS_ERR                TOUCHKEY->FR.BIT.IFGO == 1
#define TK_SCAN_IS_END              TOUCHKEY->FR.BIT.IFAVE == 1
#define TK_COUNT_IS_OVER            TOUCHKEY->FR.BIT.IFCOUNT == 1

#define CLR_ALL_TK_IF()             {                                  \
                                        TOUCHKEY->FR.BIT.IFERRC   = 1; \
                                        TOUCHKEY->FR.BIT.IFGOC    = 1; \
                                        TOUCHKEY->FR.BIT.IFAVEC   = 1; \
                                        TOUCHKEY->FR.BIT.IFCOUNTC = 1; \
                                    }
                                    
                                    
#define TK_CMP_DELAY_8SCK()         TOUCHKEY->CR.BIT.CMPD=0;
#define TK_CMP_DELAY_16SCK()        TOUCHKEY->CR.BIT.CMPD=1;
#define TK_CMP_DELAY_32SCK()        TOUCHKEY->CR.BIT.CMPD=2;
#define TK_CMP_DELAY_64SCK()        TOUCHKEY->CR.BIT.CMPD=3;
                                    
#define TK_DISCHG_256SCK()          TOUCHKEY->CR.BIT.TUNE=0;
#define TK_DISCHG_384SCK()          TOUCHKEY->CR.BIT.TUNE=1;
#define TK_DISCHG_512SCK()          TOUCHKEY->CR.BIT.TUNE=2;
#define TK_DISCHG_640SCK()          TOUCHKEY->CR.BIT.TUNE=3;
                                    
#define TK_INTERRUPT_EN()           TOUCHKEY->CR.BIT.IE = 1;
                                    
#define SET_TK_VREF(TK_VREF)        {TOUCHKEY->CR1.BIT.VREF = TK_VREF;}
#define SET_TK_VTK(TK_VOP)          {TOUCHKEY->CR1.BIT.VTK = TK_VOP;}

#define SET_TK_DIV(Tempdiv)         {TOUCHKEY->TKDIV = Tempdiv;}
#define SET_TK_FREQ_PRE(FreqPre)    {TOUCHKEY->CR.BIT.ST = FreqPre;}
                                    
#define TK_DATA_RAM_ADDR            0x4000481C;

/******************************NVIC macro definition***********************************/
#ifndef NVIC_PriorityGroup_0
#define NVIC_PriorityGroup_0        ((uint32_t)0x700) /*!< 0 bits for pre-emption priority
                                                           4 bits for subpriority */
#endif

#ifndef NVIC_PriorityGroup_1
#define NVIC_PriorityGroup_1        ((uint32_t)0x600) /*!< 1 bits for pre-emption priority
                                                           3 bits for subpriority */
#endif

#ifndef NVIC_PriorityGroup_2
#define NVIC_PriorityGroup_2        ((uint32_t)0x500) /*!< 2 bits for pre-emption priority
                                                           2 bits for subpriority */
#endif

#ifndef NVIC_PriorityGroup_3
#define NVIC_PriorityGroup_3        ((uint32_t)0x400) /*!< 3 bits for pre-emption priority
                                                           1 bits for subpriority */
#endif

#ifndef NVIC_PriorityGroup_4
#define NVIC_PriorityGroup_4        ((uint32_t)0x300) /*!< 4 bits for pre-emption priority
                                                           0 bits for subpriority */
#endif

/******************************Timer macro definition**************************************/
#define SYS_BASE_TIME               (uint8_t)5                 //ϵͳʱ䣨ms
#define PRESCALE                    (uint16_t)23               //ԤƵϵ

#define TIM                         TIM5                       //޸Timerʱ,Ҫ漸궨Ҫһ޸ġ
#define TIMER_CLOCK_ON()            {                                           \
                                        APB0_CFG->RCCLOCK            = 0x33CC;  \
                                        APB0_CFG->APB0ENR.BIT.TIM5EN = 1;       \
                                        APB0_CFG->RCCLOCK            = 0;       \
                                    }
#define TIM_IRQ                     35
#define TIM_Handler()               TIM5_Handler()

extern uint8_t f_5ms;
extern uint8_t f_30ms;

/********************************bit macro definition**************************************/
#define BIT0                  0x0001
#define BIT1                  0x0002
#define BIT2                  0x0004
#define BIT3                  0x0008
#define BIT4                  0x0010
#define BIT5                  0x0020
#define BIT6                  0x0040
#define BIT7                  0x0080
#define BIT8                  0x0100
#define BIT9                  0x0200
#define BIT10                 0x0400
#define BIT11                 0x0800
#define BIT12                 0x1000
#define BIT13                 0x2000
#define BIT14                 0x4000
#define BIT15                 0x8000

/********************************Function declaration**************************************/
#if EN_DATAADJUST
/*ڷ*/
void StartSend(void);

/*ֹͣڷ*/
void StopSend(void);

#if TOUCH_ADJUST
/*UARTһByte*/
uint8_t UartReceByte(void);
#endif

/*ARTһByte*/
void UartSendByte(uint8_t TempValue);

/*ڳʼ*/
void TK_Uart_Init(void);
#endif

/*رTouchKey*/
void DisTk(void);

/*ɨŵ*/
void EnTk(uint8_t n);

/*ɨŵIO*/
void EnIO(uint8_t n);

/*Get the Touch Sample Data object*/
uint16_t GetTouchSampleData(uint8_t channel);

/*Timer ʱʼ*/
void TimerInit(void);
#endif
